com.trendmicro.ds.platform.rest.api

## Interface ISmartFoldersAPI

-     @Produces(value="application/json")
       @Consumes(value="application/json")
       @Path(value="/smart-folders")
      public interface ISmartFoldersAPI

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `CreateSmartFolderResponse` | `createSmartFolder(java.lang.String sID, CreateSmartFolderRequest request)` Creates a new smart folder.
    `void` | `deleteSmartFolder(java.lang.String sID, long smartFolderID)` Deletes a smart folder.
    `ListParentSmartFolderResponse` | `getParentSmartFolders(java.lang.String sID, long smartFolderID)` Lists the Parent Smart Folders for a Smart Folder
    `SmartFolder` | `getSmartFolder(java.lang.String sID, long smartFolderID)` Gets the details of one smart folder.
    `ListHostsResponse` | `listHosts(java.lang.String sID, long smartFolderID)` Lists the hosts that are in a Smart Folder.
    `ListSmartFoldersResponse` | `listSmartFolders(java.lang.String sID)` Returns a list of all Smart Folders.
    `void` | `synchronizeSmartFolder(java.lang.String sID, long smartFolderID)` Synchronizes a smart folder.
    `void` | `updateSmartFolder(java.lang.String sID, long smartFolderID, UpdateSmartFolderRequest request)` Updates a smart folder.

- - ### Method Detail

    - #### createSmartFolder

          @POST
          CreateSmartFolderResponse createSmartFolder(@CookieParam(value="sID")
                                                            java.lang.String sID,
                                                            CreateSmartFolderRequest request)
                                                     throws java.lang.Exception

      Creates a new smart folder.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `request` - a `CreateSmartFolderRequest` object describing the smart folder.
      Returns:
        a `CreateSmartFolderResponse` containing the ID of the created smart folder.
      Throws:
        `java.lang.Exception`

    - #### updateSmartFolder

          @Path(value="{smartFolderID}")
           @POST
          void updateSmartFolder(@CookieParam(value="sID")
                                                                       java.lang.String sID,
                                                                       @PathParam(value="smartFolderID")
                                                                       long smartFolderID,
                                                                       UpdateSmartFolderRequest request)
                                                                throws java.lang.Exception

      Updates a smart folder.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `request` - a `CreateSmartFolderRequest` object describing the smart folder.
      Throws:
        `java.lang.Exception`

    - #### listSmartFolders

          @GET
          ListSmartFoldersResponse listSmartFolders(@CookieParam(value="sID")
                                                         java.lang.String sID)
                                                  throws java.lang.Exception

      Returns a list of all Smart Folders.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
      Returns:
        a list of all Smart Folders
      Throws:
        `java.lang.Exception`

    - #### getSmartFolder

          @Path(value="{smartFolderID}")
           @GET
          SmartFolder getSmartFolder(@CookieParam(value="sID")
                                                                          java.lang.String sID,
                                                                          @PathParam(value="smartFolderID")
                                                                          long smartFolderID)
                                                                   throws java.lang.Exception

      Gets the details of one smart folder.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `smartFolderID` - the smart folder ID.
      Returns:
      Throws:
        `java.lang.Exception`

    - #### deleteSmartFolder

          @Path(value="{smartFolderID}")
           @DELETE
          void deleteSmartFolder(@CookieParam(value="sID")
                                                                         java.lang.String sID,
                                                                         @PathParam(value="smartFolderID")
                                                                         long smartFolderID)
                                                                  throws java.lang.Exception

      Deletes a smart folder.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `smartFolderID` - the smart folder ID.
      Throws:
        `java.lang.Exception`

    - #### synchronizeSmartFolder

          @Path(value="{smartFolderID}/synchronize")
           @POST
          void synchronizeSmartFolder(@CookieParam(value="sID")
                                                                                        java.lang.String sID,
                                                                                        @PathParam(value="smartFolderID")
                                                                                        long smartFolderID)
                                                                                 throws java.lang.Exception

      Synchronizes a smart folder. This is only applicable for a smart folder with an AWS tag hierarchy.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `smartFolderID` - the smart folder ID.
      Throws:
        `java.lang.Exception`

    - #### getParentSmartFolders

          @Path(value="{smartFolderID}/getParentSmartFolders")
           @GET
          ListParentSmartFolderResponse getParentSmartFolders(@CookieParam(value="sID")
                                                                                                                         java.lang.String sID,
                                                                                                                         @PathParam(value="smartFolderID")
                                                                                                                         long smartFolderID)
                                                                                                                  throws java.lang.Exception

      Lists the Parent Smart Folders for a Smart Folder
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `smartFolderID` - the smart folder ID.
      Throws:
        `java.lang.Exception`

    - #### listHosts

          @Path(value="{smartFolderID}/hosts")
           @GET
          ListHostsResponse listHosts(@CookieParam(value="sID")
                                                                                 java.lang.String sID,
                                                                                 @PathParam(value="smartFolderID")
                                                                                 long smartFolderID)
                                                                          throws java.lang.Exception

      Lists the hosts that are in a Smart Folder.
      Parameters:
        `sID` - a session ID returned by the Authentication API.
        `smartFolderID` - the smart folder ID.
      Throws:
        `java.lang.Exception`

Copyright © 2017 Trend Micro Inc. All Rights Reserved.